/**
  *  \file filenames.h
  *  \brief File and File Name Handling
  */
#ifndef FILENAMES_H_INCLUDED
#define FILENAMES_H_INCLUDED

#include <string>

//@{
///\ingroup unix

std::string getDirectoryName(std::string s);
std::string getBaseName(std::string s);
std::string getFileNameFromUrl(std::string host, std::string s);
std::string getFileUrl(std::string name);
std::string makeFileName(std::string basedir, std::string name);
std::string getSettingsFileName();
bool isExistingFileName(std::string name);
bool createDirectories(std::string name);

//@}

#endif
