/**
  *  \file thread.cpp
  */

#include "thread.h"

// FIXME: this never destroys the thread's HANDLE.

/** Constructor. */
Thread::Thread()
    : m_Thread(0), m_StackSize(16384)
{ }

/** Destructor. Note that when the thread object dies before the
    thread is joined, its identifier is lost. */
Thread::~Thread()
{ }

DWORD WINAPI
Thread::threadFunc(LPVOID p)
{
    static_cast<Thread*>(p)->run();
    return 0;
}

/** Exit thread. To be called from run(). */
void
Thread::exit()
{
    ExitThread(0);
}

/** Set stack size. Call this before start().
    \param n Desired stack size in bytes */
void
Thread::setStackSize(int n)
{
    m_StackSize = n;
}

/** Start the thread. This creates the actual thread and invokes its
    run() function. */
bool
Thread::start()
{
    DWORD tid;
    m_Thread = CreateThread(0, m_StackSize, threadFunc, this, 0, &tid);
    return (m_Thread != 0);
}

/** Wait for thread exist. Waits until the thread has terminated. */
void
Thread::join()
{
    WaitForSingleObject(m_Thread, INFINITE);
}
