/**
  *  \file thread.h
  */
#ifndef THREAD_H_INCLUDED
#define THREAD_H_INCLUDED

#include <windows.h>

/** Thread class. Reference to an asynchrounously running part of the
    program. User implements a thread by deriving from this class and
    implementing its run() method. */
class Thread {
    HANDLE m_Thread;

    DWORD m_StackSize;

    static DWORD WINAPI threadFunc(LPVOID);
 protected:
    void exit();

    virtual void run() = 0;
 public:
    Thread();

    virtual ~Thread();

    void setStackSize(int n);

    bool start();

    void join();
};

#endif
