/**
  *  \file evaluator.h
  *  \brief Evaluating finished requests
  */
#ifndef EVALUATOR_H_INCLUDED
#define EVALUATOR_H_INCLUDED

#include <string>

class Request;

class Evaluator {
 public:
    enum Status {
        /** Request succeeded completely, we don't have evidence of a
            failure. */
        StatusSucceeded,
        /** Network transaction ok, but turn had warnings. */
        StatusTurnWarning,
        /** Network transaction ok, but turn was not accepted. */
        StatusTurnError,
        /** Request failed completely, network transaction failed. */
        StatusFailed
    };

    Evaluator();

    void evaluateRequest(Request* r);

    std::string getDescription() const;

    Status getStatus() const
        { return m_Status; }

 private:
    std::string m_Description;

    Status m_Status;

    void setState(std::string desc, Status status);
};

#endif
