/**
  *  \file net/config.h
  *  \brief Network Configuration
  *  \author Stefan Reuther
  */
#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED

#include "propertyobject.h"

/** Interface for SMTP configuration. \see Smtp */
class SmtpConfig : public PropertyObject {
 public:
    void enumerate(KVEnumerator& e);
    bool assign(std::string name, std::string value, LoaderState& st);

    static SmtpConfig instance;
};

/** Interface for HTTP configuration. \see Http */
class HttpConfig : public PropertyObject {
 public:
    void enumerate(KVEnumerator& e);
    bool assign(std::string name, std::string value, LoaderState& st);

    static HttpConfig instance;
};

#endif
