/**
  *  \file socketstream.h
  */
#ifndef SOCKETSTREAM_H_INCLUDED
#define SOCKETSTREAM_H_INCLUDED

#include <ios>
#include <ostream>
#include "socket.h"

/** Stream buffer writing into a socket. */
class SocketStreambuf : public std::streambuf {
    Socket fd;
    char buffer[4096];
 public:
    SocketStreambuf(Socket fd);

    int overflow(int);

    int sync();
};

/** Stream writing into a socket. This just makes the SocketStreambuf
    a little easier to use. */
class SocketStream : public std::ostream {
    SocketStreambuf sb;
 public:
    SocketStream(Socket fd);

    ~SocketStream();
};

#endif
