/**
  *  \file execute.h
  *  \brief Executing stuff
  */
#ifndef EXECUTE_H_INCLUDED
#define EXECUTE_H_INCLUDED

#include <list>
#include <windows.h>
#include "selection.h"

//@{
///\ingroup wingui

class Action;
class Selection;
class WorkerThread;
class Request;

extern WorkerThread network_thread;

class Executer {
    int m_NumJobs;
    
    std::list<Selection> m_PendingRequests;

 public:
    Executer();

    void runAction(HWND window, Selection& sel);

    bool isPendingAction(const Selection& sel) const;

    void pushRequest(const Selection& sel, Request* r);

    Request* popFinishedRequest();

    int getNumActiveJobs() const
        { return m_NumJobs; }
};

//@}

#endif
