/**
  *  \file networkpanel.h
  *  \brief Network Panel Widget
  */
#ifndef NETWORKPANEL_H_INCLUDED
#define NETWORKPANEL_H_INCLUDED

#include "api.h"

//@{
///\ingroup wingui

class Executer;

class NetworkPanel : public Window {
    Executer& m_Exec;

    HWND m_Hwnd;

    void draw(HWND hwnd, HDC dc);

    static HFONT m_Font;
    static int m_DefaultHeight, m_DefaultWidth;
 public:
    NetworkPanel(Executer& exec);

    ~NetworkPanel();

    LRESULT handle(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);

    HWND create(int x,                       // horizontal position of window
                int y,                       // vertical position of window
                int nWidth,                  // window width
                int nHeight,                 // window height
                HWND hWndParent);            // handle to parent or owner window

    void update();

    HWND getWindowHandle() const
        { return m_Hwnd; }

    static int getDefaultWidth()
        { return m_DefaultWidth; }

    static int getDefaultHeight()
        { return m_DefaultHeight; }

    static void init();
};

//@}

#endif
